local HOLDFLY = "client/fyromentum/holdfly.dat"
local FLIPS = "client/fyromentum/flips.dat"
local BOOSTHUD = "client/fyromentum/boosthud.dat"
local BOOSTINDI = "client/fyromentum/boostindi.dat"

local configplayer

local function valid(mo)
	return mo and mo.valid
end

--i took some of this from xmom, ill replace it with my own code once i find out how
addHook("ThinkFrame", do
	if valid(consoleplayer)
	and not valid(configplayer)
	and consoleplayer.holdfly == nil
		configplayer = consoleplayer
		local file = io.openlocal(HOLDFLY)
        if file
            local num = file:read("*n")
			if num == 1
				COM_BufInsertText(consoleplayer, "holdfly ".."on")
			else
				COM_BufInsertText(consoleplayer, "holdfly ".."off")
			end
			file:close()
        else
			COM_BufInsertText(consoleplayer, "holdfly on")
        end
		
		local file2 = io.openlocal(FLIPS)
        if file2
            local num = file2:read("*n")
			if num == 1
				COM_BufInsertText(consoleplayer, "flips ".."on")
			else
				COM_BufInsertText(consoleplayer, "flips ".."off")
			end
			file2:close()
        else
			COM_BufInsertText(consoleplayer, "flips on")
        end
		
		local file3 = io.openlocal(BOOSTHUD)
        if file3
            local num = file3:read("*n")
			if num == 1
				COM_BufInsertText(consoleplayer, "boosthud ".."on")
			else
				COM_BufInsertText(consoleplayer, "boosthud ".."off")
			end
			file3:close()
        else
			COM_BufInsertText(consoleplayer, "boosthud on")
        end
	end
end)

local function HoldFlyCommand(player, arg)
	if player and player.mo and player.mo.valid
		if player.mo.skin == "tails"
			if arg == "on"
				player.holdfly = 1
				CONS_Printf(player, "You can now hold JUMP to fly with Tails.")
				if io and player == consoleplayer
					local file = io.openlocal(HOLDFLY, "w+")
					file:write(player.holdfly)
					file:close()
				end
			elseif arg == "off"
				player.holdfly = 2
				CONS_Printf(player, "Hold fly turned off.")
				if io and player == consoleplayer
					local file = io.openlocal(HOLDFLY, "w+")
					file:write(player.holdfly)
					file:close()
				end
			else
				CONS_Printf(player, "If true, you can hold jump instead of tapping to fly.")
			end
		else
			CONS_Printf(player, "You aren't Tails!")
		end
	end
end

local function SpringFlipsCommand(player, arg)
	if player and player.mo and player.mo.valid
		if arg == "on"
			player.springflips = 1
			CONS_Printf(player, "Hitting a spring in the air will now make you do flips.")
			if io and player == consoleplayer
				local file = io.openlocal(FLIPS, "w+")
				file:write(player.springflips)
				file:close()
			end
		elseif arg == "off"
			player.springflips = 2
			CONS_Printf(player, "Spring flips are off.")
			if io and player == consoleplayer
				local file = io.openlocal(FLIPS, "w+")
				file:write(player.springflips)
				file:close()
			end
		else
			CONS_Printf(player, "If true, going high in the air will make you spin. (YOU WILL BE VULNERABLE!)")
		end
	end
end

local function BoostHudCommand(player, arg)
	if player and player.mo and player.mo.valid
		if arg == "on"
			player.fyromentumhud = 1
			CONS_Printf(player, "The hud for showing the boost gauge will show.")
			if io and player == consoleplayer
				local file = io.openlocal(BOOSTHUD, "w+")
				file:write(player.fyromentumhud)
				file:close()
			end
		elseif arg == "off"
			player.fyromentumhud = 0
			CONS_Printf(player, "Boost HUD is off.")
			if io and player == consoleplayer
				local file = io.openlocal(BOOSTHUD, "w+")
				file:write(player.fyromentumhud)
				file:close()
			end
		else
			CONS_Printf(player, "If true, the boost gauge will be shown in-game.")
		end
	end
end

local function BoostIndiCommand(player, arg)
	if player and player.mo and player.mo.valid
		if arg == "on"
			player.boostindication = 1
			CONS_Printf(player, "Lines on the boost gauge will show for all boost levels.")
			if io and player == consoleplayer
				local file = io.openlocal(BOOSTINDI, "w+")
				file:write(player.boostindication)
				file:close()
			end
		elseif arg == "off"
			player.boostindication = 0
			CONS_Printf(player, "Boost Indicator is off.")
			if io and player == consoleplayer
				local file = io.openlocal(BOOSTINDI, "w+")
				file:write(player.boostindication)
				file:close()
			end
		else
			CONS_Printf(player, "If true, lines on the boost gauge will show.")
		end
	end
end

local function MomentumEnabledCommand(player, arg) -- shouldnt need a file for this
	if player and player.mo and player.mo.valid
		if arg == "on"
			player.fyromentum = 1
			CONS_Printf(player, "Fyromentum is now enabled.")
		elseif arg == "off"
			player.fyromentum = 0
			CONS_Printf(player, "Fyromentum disabled.")
		else
			CONS_Printf(player, "If true, Fyromentum's momentum ablities will be enabled. (Base characters will still have extra abilities)")
		end
	end
end

COM_AddCommand("holdfly", function(player, arg)
	HoldFlyCommand(player, arg)
end)

COM_AddCommand("springflips", function(player, arg)
	SpringFlipsCommand(player, arg)
end)

COM_AddCommand("boosthud", function(player, arg)
	BoostHudCommand(player, arg)
end)

COM_AddCommand("boostindication", function(player, arg)
	BoostIndiCommand(player, arg)
end)

COM_AddCommand("momentumtoggle", function(player, arg)
	MomentumEnabledCommand(player, arg)
end)